(**********************************************************************
*                                                                     *
*                 ন ।⢠   About                *
*                                                                     *
**********************************************************************)
{$O-}
                             unit  About;
                               interface

uses  Objects, Drivers, Views, Menus, TextView, Dialogs, App,
      MsgBox, StdDlg, Crt,
      Figaro, WinProcs, Commands;

const   CAbout= ^C'Figaro Demo Program'^M+
                ^C''^M+
                ^C'Derevenets Oleg'^M+
                ^C'Copyright (c) Dec 1997'^M+
                ^C'Voronezh, Russia';
        CLen  = length(CAbout);
        CBlank= '.';

type
      PProcessSound = ^TProcessSound;
      TProcessSound = object (TProcess)
         procedure  Lock;   virtual;
         procedure  Stop;   virtual;
         procedure  Delete; virtual;
      end;

      PWinAbout = ^TWinAbout;
      TWinAbout = object (TDialog)
        _Process : String;
        _Expo : PStaticText;
        _Text : string[CLen];
        _Mask : set of 1..CLen;
        _Flag : boolean;
        constructor Init(Point : TPoint; Process : PProcess);
        destructor  Done; virtual;
        procedure   HandleEvent (var E : TEvent); virtual;
        function    Refresh: boolean;
      end;

procedure MakeAbout;
{}
                             implementation
{}
procedure  TProcessSound.Lock;
begin
  Inherited Lock;
  NoSound;
end;

procedure  TProcessSound.Stop;
begin
  Inherited Stop;
  NoSound;
end;
procedure  TProcessSound.Delete;
begin
  Inherited Delete;
  NoSound;
end;


constructor  TWinAbout.Init (Point : TPoint; Process : PProcess);
var R: TRect;
    i: integer;
begin
  R.Assign(0,0, 32, 7);
  R.Move (Point.X, Point.Y);
  if not inherited Init(R, Process^.GetName) then Fail;
  _Process := Process^.GetName;
  _Mask := [];
  _Flag := false;
  _Text := CAbout;
  for i:=1 to Length(_Text) do
      if _Text[i]>= #32 then _Text[i]:=CBlank;
  GetExtent(R);  R.Grow(-1,-1);
  _Expo := New(PStaticText, Init(R,_Text));
  Insert (_Expo);
  Process^._ParamPtr:=@Self;
  Insert_Process (Process);
end;

destructor  TWinAbout.Done;
begin
  Delete_Process (_Process);
  inherited Done;
end;

function  TWinAbout.Refresh: boolean;
var i : integer;
    s : string[CLen];
begin
  if _Flag
     then begin
           repeat  i:= 1+ Random (CLen); until i in _Mask;
           _Mask:= _Mask-[i];
           if ord(_Text[i]) >= 32  then _Text[i]:=CBlank;
           _Flag:= _Mask <>[];
          end
     else begin
           s:= CAbout;
           repeat  i:= 1+ Random (CLen); until not (i in _Mask);
           _Mask:= _Mask+[i];
           _Text[i]:=s[i];
           _Flag:= _Mask =[1..CLen];
          end;
  with _Expo^ do
   begin
    if not Assigned(Text)
       then   Text := NewStr (_Text)
       else   Text^:=_Text;
    DrawView;
   end;
  Refresh:= _Flag;
end;

procedure   TWinAbout.HandleEvent (var E : TEvent);
begin
  inherited HandleEvent (E);
  if (E.What and evMessage) <> 0 then
     case E.Command of
      cmLock   : Lock_Process    (_Process);
      cmUnLock : UnLock_Process  (_Process);
      cmSuspend: Suspend_Process (_Process, CSecond * 15);
      cmResume : Resume_Process  (_Process);
      cmStop   : Stop_Process    (_Process);
      cmDelete : Close;
      else  Exit;
     end;
  ClearEvent(E);
end;

{$F+}
procedure Process_About;
var   WinPtr : PWinAbout;
      Flag, Direct, F : boolean;
begin
  StartPause;
  WinPtr:= Get_MyParamPtr;
  Direct:= true;
  repeat
    if Direct then Pause(CSecond) else Pause(5*CSecond);
    repeat
       if F then Sound(35); F:=not F;
       Pause (CSecond div 50);
       Flag:= WinPtr^.Refresh;
       NoSound;
    until  Flag = Direct;
    NoSound;
    Direct:= not Direct;
  until false
end;
{$F-}

procedure MakeAbout;
const count: integer = 0;

var   W : PWinAbout;
      P : PProcessSound;
      Point : TPoint;
      s : string;
begin
  with Point do begin
    X:= 1+Random(40);
    Y:= 1+Random(15);
  end;
  Inc (Count);  Str(Count, s);  s:='About # '+s;
  Disable_Interrupt;
  New(P, Init(s, true, 300, 50, 0, Stack(1100), @Process_About, nil));
  if Assigned(P) then begin
     New(W, Init (Point, P));
     Application^.InsertWindow(W);
  end;
  Enable_Interrupt;
end;

end.
